(define (square x)
  (* x x))
(define (test num m)
  (if (and
       (> num 1)
       (< num (- m 1))
       (=
        (remainder (square num) m)
        1))
      0
      num))

(define (expmod base exp m)
  (cond ((= exp 0) 1)
        ((even? exp) 
         (test (modulo (square (expmod base (/ exp 2) m))
                          m) m))
        (else
         (modulo (* base (expmod base (- exp 1) m))
                    m))))

(define (try-it n a)
  (= (expmod a (- n 1) n) 1))

(define (mr-test n)
  (cond ((<= n 1) #f)
        ((= n 2) #t)
        (else (try-it n (+ 1 (random (- n 2)))))))

(define (fast-prime? n times)
  (cond ((= times 0) #t)
        ((mr-test n) (fast-prime? n (- times 1)))
        (else #f)))

(define (prime? n)
  (fast-prime? n 100))

(define (smallest-prime n)
  (if (prime? n) n (smallest-prime (+ 1 n))))

(define (order n p)
  (define (order-inner result)
    (if (= result 1) 0 (+ 1 (order-inner (remainder (* n result) p)))))
  (+ 1 (order-inner n)))

(define (generator? p n)
  (= (order n p) (- p 1)))

(define (smallest-generator p)
  (define (inner now)
    (if (generator? p now) now (inner (+ 1 now))))
  (inner 2))


